'*********************************************************************************************************
'*  Version fr Lochrasterplatine fr Modelleisenbahner !!! Version mit Quarz !!!
'*  Experimente mit Vorteiler aber nur 128 Schritten
'*  erlaubt auch "kurze Zeiten" im PC-Modus aber nur mit 128 Schritten
'*  Programmversion 13.01.2019 fr Universalplatine
'*  Unterschied 04.11.2018: Fehler bei der Ausgabe der Kx-Werte
'*  beseitigt: Zhler war noch bis 254 statt bis 128
'*  Version fr 24 Ausgnge fr Wohnraumbeleuchtung
'*  oder andere Zwecke
'*  Peter Grundmann   peter@groupiemebtron.de    www.groupiemebtron.de
'*  Der C reagiert auf Befehle von der seriellen Schnittstelle
'*  Diese mssen 14 Zeichen + CR lang sein, alles andere wird ignoriert
'*  Im Modus 0 (Jumper wirksam):
'*      "Modus:2       " schaltet den Modus 2 ein
'*  Im Modus 2 (Einstellung per PC):
'*      "Modus:0       " schaltet den Modus 0 ein
'*      "Modus:1       " schaltet den Test-Modus per PC ein
'*      "Ausgabe       " EEPROM-Inhalt wird ausgegeben
'*      "Modus_k2:0    " schaltet den Modus 0 fr K2 aktiv (Blinklichter)
'*      "Modus_k2:1    " schaltet den Modus 1 fr K2 aktiv (Wohnhaus)
'*      "Modus_k3:0    " schaltet den Modus 0 fr K3 aktiv (Leuchtstoffrhren)
'*      "Modus_k3:1    " schaltet den Modus 1 fr K3 aktiv (Wohnhaus)
'*      "Modus_k4:0    " schaltet den Modus 0 fr K4 aktiv (Lauflicht, hin- und her wandernder Lichtpunkt)
'*      "Modus_k4:1    " schaltet den Modus 1 fr K4 aktiv (Lauflicht, aufwrts wandernder Lichtpunkt)
'*      "Modus_k4:2    " schaltet den Modus 2 fr K4 aktiv (Lauflicht, wachsender Balken )
'*      "Modus_k4:3    " schaltet den Modus 3 fr K4 aktiv (Wohnhaus an K4)
'*
'*      "Timer0  :1024 " schaltet den Vorteiler auf 1024
'*      "Timer0  :256  " schaltet den Vorteiler auf 256
'*
'*      Weitere Befehle mssen folgendes Format haben:
'*      "123456:xxx:yyy" d. h. 6 Zeichen plus 2 Parameter die mit einem Doppelpunkt getrennt werden
'*      "K2_max:xxx:yyy" xxx enthlt den Wert fr Zaehlerk2_max_eeprom
'*      "K3_max:xxx:yyy" xxx enthlt den Wert fr Zaehlerk3_max_eeprom
'*      "K4_max:xxx:yyy" xxx enthlt den Wert fr Zaehlerk4_max_eeprom
'*      "K2_sch:xxx:yyy" xxx enthlt den Wert fr Max_schritte_k2_eeprom
'*      "K3_sch:xxx:yyy" xxx enthlt den Wert fr Max_schritte_k3_eeprom
'*      "K4_sch:xxx:yyy" xxx enthlt den Wert fr Max_schritte_k4_eeprom
'*      "K2wert:xxx:yyy" xxx enthlt den Index fr K2_eeprom(), yyy den Wert
'*      "K3wert:xxx:yyy" xxx enthlt den Index fr K3_eeprom(), yyy den Wert
'*      "K4wert:xxx:yyy" xxx enthlt den Index fr K4_eeprom(), yyy den Wert
'*      "Synchr:xxx:yyy" xxx enthlt den Wert fr Synchron
'*      "Invert:xxx:yyy" xxx enthlt den Wert fr Invertiert
'*      "K2test:xxx:yyy" xxx enthlt den Wert der auf K2 zu schreiben ist
'*      "K3test:xxx:yyy" xxx enthlt den Wert der auf K3 zu schreiben ist
'*      "K4test:xxx:yyy" xxx enthlt den Wert der auf K4 zu schreiben ist
'*  Im EEPROM werden fr K2 bis 4 jeweils 128 Werte reserviert.
'*  Es konnen aber nur 128 genutzt werden weil das EEPROM nicht mehr hergibt.
'*********************************************************************************************************

$regfile = "m16adef.dat"
$hwstack = 40
$swstack = 16
$framesize = 32
$crystal = 2000000                                          'Taktfrequenz auf 2MHz eingestellt, fr Wartezeiten-Berechnung
$baud = 19200

$PROG &HFC , &HAC , &HC1 , &H00                             'Fuse-Bits fr 2MHz-Quarz-Oszillator

Config Serialout = Buffered , Size = 100                    'Gepufferte Ausgabe ber serielle Schnittstelle

'Variablen-Deklarationen, zuerst im EEPROM dann im RAM
Dim K2_eeprom(128) As Eram Byte                             'nimmt das Muster fr Wohnhaus auf
Dim K3_eeprom(128) As Eram Byte
Dim K4_eeprom(128) As Eram Byte
Dim Flackern(112) As Eram Byte                              'Flackermuster fr Leuchtstoffrhren
Dim Modus_eeprom As Eram Byte                               'Modus 1: Testmodus Jumper
                                                              'Modus 2: Betrieb mit den am PC vorgenommenen Einstellungen
                                                              'Modus 3: Testmodus Jumper
                                                              'Modus 4: Programmierung durch PC, Jumper wirkungslos
Dim Modus_k2_eeprom As Eram Byte
Dim Modus_k3_eeprom As Eram Byte
Dim Modus_k4_eeprom As Eram Byte
Dim Zaehlerk2_max_eeprom As Eram Byte
Dim Zaehlerk3_max_eeprom As Eram Byte
Dim Zaehlerk4_max_eeprom As Eram Byte
Dim Max_schritte_k2_eeprom As Eram Byte
Dim Max_schritte_k3_eeprom As Eram Byte
Dim Max_schritte_k4_eeprom As Eram Byte
Dim Synchron_eeprom As Eram Byte                            'die drei Ausgnge laufen synchron
Dim Invertiert_eeprom As Eram Byte                          'Ausgnge invertiert
Dim Vorteiler_eeprom As Eram Byte                           'Wert fr Vorteiler: 5 = 1024; 4 = 256

'Nun kommen die Variablen fr die Overlays gelten damit die sich nicht mehr verschieben
Dim Befehl As String * 15                                   'der komplette Befehl als String; Start bei 00C7hex = 199 dezimal
Dim Wert1 As String * 3 At 206 Overlay                      'Wert hngt davon ab ob Puffer fr serielle Ausgabe definiert ist!
Dim Wert2 As String * 3 At 210 Overlay                      'wie oben
Dim Befehlsammeln As String * 15                            'Hilfs-String fr Sammeln whrend der letzte Befehl verarbeitet wird
Dim Befehlsamm(15) As Byte At Befehlsammeln Overlay         '

'Jetzt kommen die restlichen Variablen, zuerst die Bits
Dim K2_verarbeiten As Bit                                   'Flag
Dim K3_verarbeiten As Bit
Dim K4_verarbeiten As Bit
Dim Leuchtstoff As Bit                                      'Leuchtstoffrhren an =0  oder aus =1
Dim Neustart As Bit
Dim Befehlkomplett As Bit

'nun die Bytes...
Dim Modus As Byte                                           'Modus 0: Werkseinstellung, d. h. Beeinflussung durch Jumper
Dim Modus_k2 As Byte                                        'wenn 1 dann Wohnhaus, sonst Blinklichter
Dim Modus_k3 As Byte                                        'wenn 1 dann Wohnhaus, sonst Leuchtstoffrhren
Dim Modus_k4 As Byte                                        '3 = Wohnhaus, 2, 1 und 0 = Lauflicht2 bzw. -1 oder -0
Dim Zaehlerk2 As Byte                                       'Zhler in Timer0 fr K2
Dim Zaehlerk2_max As Byte                                   'Maximalwert von ZaehlerK2 fr K2
Dim Max_schritte_k2 As Byte
Dim Zaehlerk3 As Byte                                       'Zhler in Timer0 fr K3
Dim Zaehlerk3_max As Byte                                   'Maximalwert von Zaehlerk3 fr K3
Dim Max_schritte_k3 As Byte
Dim Zaehlerk4 As Byte                                       'Zhler in Timer0 fr K4
Dim Zaehlerk4_max As Byte                                   'Maximalwert von Zaehlerk4 fr K4
Dim Max_schritte_k4 As Byte
Dim K2_wert As Byte
Dim K3_wert As Byte
Dim K4_wert As Byte
Dim Zaehler4 As Byte                                        'Zahler in Timer2
Dim Zaehler4_alt As Byte                                    'zur Erkennung berlauf von Timer0 fr Leuchtstoffrhren
Dim Zaehler5 As Byte                                        'fr Blinklicht
Dim Zaehler5_alt As Byte
Dim Wechselblinker As Byte                                  'auch fr Blinklicht
Dim Rettungsfahrzeug As Byte
Dim Blinker As Byte
Dim Schleife As Byte
Dim Hilf As Byte
Dim K2_schritt As Byte
Dim K3_schritt As Byte
Dim K4_schritt As Byte
Dim Lauflicht As Byte
Dim Leuchtstoffzaehler As Byte                              'Zhler zum Starten
Dim Zeichen As Byte                                         'das gerade empfangene Zeichen von der seriellen Schnittstelle
Dim Stringzaehler As Byte
Dim Test As Byte
Dim Befehl6 As String * 6
Dim Param1 As Byte
Dim Param2 As Byte
Dim Zaehlerk4_alt As Byte
Dim Synchron As Byte
Dim Invertiert As Byte
Dim Vorteiler As Byte

'nun die Eingnge, alle mit Pullup ein
Config Portd.0 = Input : Portd.0 = 1                        'das ist RxD, muss mit Pullup sein sonst spinnt die Mimik!
J1 Alias Pinb.6 : Config Portb.6 = Input : Portb.6 = 1
J2 Alias Pinb.7 : Config Portb.7 = Input : Portb.7 = 1
J3 Alias Pind.2 : Config Portd.2 = Input : Portd.2 = 1
J4 Alias Pind.3 : Config Portd.3 = Input : Portd.3 = 1
J5 Alias Pind.6 : Config Portd.6 = Input : Portd.6 = 1
J6 Alias Pind.7 : Config Portd.7 = Input : Portd.7 = 1

'Timer0 wird mit Vorteiler 1024 eingestellt
'd. h. pro 0,000512 Sekunden wird die 8-Bit-Variable um 1 erhht
'nach 256 Schritten luft der Zhler ber und ein Interrupt wird aufgerufen
'das bedeutet das alle 0,131072 Sekunden die Routine IRQTIMER0 aufgerufen wird
'Vorteiler kann im Programm auf 256 umgestellt werden
Config Timer0 = Timer , Prescale = 1024
Enable Timer0
On Timer0 Irqtimer0
'Timer2 wird mit Vorteiler 256 eingestellt fr das Flackern der Leuchtstoffrhren
Config Timer2 = Timer , Prescale = 256
Enable Timer2
On Timer2 Irqtimer2
On Urxc Onrxd                                               'ISR fr Empfang eines Zeichens via serielle SS definieren
Enable Urxc                                                 'Interrupt fr serielle Schnittstelle einschalten
Enable Interrupts

'Alias-Namen wegen verdrehter Anschlussfolge
'zunchst K2, 3 und 4 als Ausgnge
K2_1 Alias Portd.4 : Config K2_1 = Output
K2_2 Alias Portd.5 : Config K2_2 = Output
K2_3 Alias Portb.5 : Config K2_3 = Output
K2_4 Alias Portb.4 : Config K2_4 = Output
K2_5 Alias Portb.3 : Config K2_5 = Output
K2_6 Alias Portb.2 : Config K2_6 = Output
K2_7 Alias Portb.1 : Config K2_7 = Output
K2_8 Alias Portb.0 : Config K2_8 = Output

K3_1 Alias Porta.0 : Config K3_1 = Output
K3_2 Alias Porta.1 : Config K3_2 = Output
K3_3 Alias Porta.2 : Config K3_3 = Output
K3_4 Alias Porta.3 : Config K3_4 = Output
K3_5 Alias Porta.4 : Config K3_5 = Output
K3_6 Alias Porta.5 : Config K3_6 = Output
K3_7 Alias Porta.6 : Config K3_7 = Output
K3_8 Alias Porta.7 : Config K3_8 = Output

K4_1 Alias Portc.7 : Config K4_1 = Output
K4_2 Alias Portc.6 : Config K4_2 = Output
K4_3 Alias Portc.5 : Config K4_3 = Output
K4_4 Alias Portc.4 : Config K4_4 = Output
K4_5 Alias Portc.3 : Config K4_5 = Output
K4_6 Alias Portc.2 : Config K4_6 = Output
K4_7 Alias Portc.1 : Config K4_7 = Output
K4_8 Alias Portc.0 : Config K4_8 = Output


Programmbeginn:
Invertiert = Invertiert_eeprom
'alles aus
K2_wert = 0
K3_wert = 0
K4_wert = 0
Gosub K2_schreiben
Gosub K3_schreiben
Gosub K4_schreiben
Zaehlerk2 = 0
Zaehlerk3 = 0
Zaehlerk4 = 0
Waitms 50
Print "Lichtcomputer"
Print "Version " ; Version(1)
Modus = Modus_eeprom                                        'darf nur 0 (Jumper) oder 2 (PC) sein! Modus 1 ist Test-Modus
Select Case Modus
   Case 0
      'Jumper sind wirksam, nun Abfrage der sonstigen Modi
      Synchron = 0
      Zaehlerk2_max = 255
      Zaehlerk3_max = 255
      Zaehlerk4_max = 255
      Modus_k2 = J1
      Modus_k3 = J2
      Modus_k4.1 = J3                                       'K4 hat 4 Modi
      Modus_k4.0 = J4
      Hilf.0 = J5                                           'nun die Geschwindigkeit in 4 Stufen
      Hilf.1 = J6
      Select Case Hilf
         Case 0
            'J5 und J6 gesteckt, ca 30 Sekunden
            Zaehlerk2_max = 229
            Zaehlerk3_max = 229
            Zaehlerk4_max = 229
         Case 1
            'J5 offen, J6 gesteckt, ca 20 Sekunden
            Zaehlerk2_max = 153
            Zaehlerk3_max = 153
            Zaehlerk4_max = 153
         Case 2
            'J5 gesteckt, J6 offen, ca. 10 Sekunden
            Zaehlerk2_max = 76
            Zaehlerk3_max = 76
            Zaehlerk4_max = 76
         Case Else                                          'Wert 3 oder irgendwas anderes
            'J5 und J6 offen, ca 5 Sekunden
            Zaehlerk2_max = 38
            Zaehlerk3_max = 38
            Zaehlerk4_max = 38                              'Normal 38, zum Test 6
      End Select
      Max_schritte_k2 = 129
      Max_schritte_k3 = 129
      Max_schritte_k4 = 129
   Case 2
      'PC-Modus wirksam
      Zaehlerk2_max = Zaehlerk2_max_eeprom
      Zaehlerk3_max = Zaehlerk3_max_eeprom
      Zaehlerk4_max = Zaehlerk4_max_eeprom
      Modus_k2 = Modus_k2_eeprom
      Modus_k3 = Modus_k3_eeprom
      Modus_k4 = Modus_k4_eeprom
      Max_schritte_k2 = Max_schritte_k2_eeprom
      Max_schritte_k3 = Max_schritte_k3_eeprom
      Max_schritte_k4 = Max_schritte_k4_eeprom
      Synchron = Synchron_eeprom
      Vorteiler = Vorteiler_eeprom
      If Vorteiler = 4 Then
         'Vorteiler auf 256 setzen, else gibt es nicht weil Standard
         Tccr0 = 4
      End If
   Case Else
      'das darf eigentlich nicht sein
      Print "Was nun? Modus ist " ; Modus
      Wait 1
      End                                                   'end program, da ist was schief gegangen!
End Select

If Synchron = 0 Then
   Zaehlerk2 = Zaehlerk2_max - 1                            'Zhler auf unterschiedliche Startwerte
   Zaehlerk3 = Zaehlerk3_max / 3                            'damit die Umschaltungen nicht alle
   Zaehlerk4 = Zaehlerk4_max / 3                            'zur gleichen Zeit passieren
   Zaehlerk4 = Zaehlerk4 + Zaehlerk4
Else
   Zaehlerk2 = 1
   Zaehlerk3 = 1
   Zaehlerk4 = 1
   Zaehlerk2_max = Zaehlerk2_max_eeprom
   Zaehlerk3_max = Zaehlerk2_max_eeprom
   Zaehlerk4_max = Zaehlerk2_max_eeprom
   Max_schritte_k2 = Max_schritte_k2_eeprom
   Max_schritte_k3 = Max_schritte_k2_eeprom
   Max_schritte_k4 = Max_schritte_k2_eeprom
End If
'Abfrage ob Test-Modus gewnscht
Test = 63
Test.0 = J1
Test.1 = J2
Test.2 = J3
Test.3 = J4
Test.4 = J5
Test.5 = J6
Print "Test: " ; Test
If Modus = 0 Then
   'dann Abfrage Testmodus
   If Test = 0 Then
      'Testmodus
      Modus_k3 = 1
      K3_8 = 1                                              'damit K3_schreiben funktioniert
      For Hilf = 1 To 3
         'leuchtender Punkt aufwrts
         For Schleife = 0 To 7
            K2_wert = 2 ^ Schleife
            Gosub K2_schreiben
            Waitms 300
         Next Schleife
         K2_wert = 0
         Gosub K2_schreiben
         For Schleife = 0 To 7
            K3_wert = 2 ^ Schleife
            Gosub K3_schreiben
            Waitms 300
         Next Schleife
         K3_wert = 0
         Gosub K3_schreiben
         For Schleife = 0 To 7
            K4_wert = 2 ^ Schleife
            Gosub K4_schreiben
            Waitms 300
         Next Schleife
         K4_wert = 0
         Gosub K4_schreiben
      Next Hilf
      K4_wert = 255
      Gosub K4_schreiben
      K3_wert = 255
      Gosub K3_schreiben
      K2_wert = 255
      Gosub K2_schreiben
      Print "Ende Test-Modus"
      Wait 1
      End
   End If
End If

Print "Modus: " ; Modus
Print "Modus_k2: " ; Modus_k2
Print "Modus_k3: " ; Modus_k3
Print "Modus_k4: " ; Modus_k4
'Print "Hilf: " ; Hilf
Print "Zaehlerk2_max: " ; Zaehlerk2_max
Print "Zaehlerk3_max: " ; Zaehlerk3_max
Print "Zaehlerk4_max: " ; Zaehlerk4_max
Print "Zaehlerk2: " ; Zaehlerk2
Print "Zaehlerk3: " ; Zaehlerk3
Print "Zaehlerk4: " ; Zaehlerk4
Print "Max_schritte_k2: " ; Max_schritte_k2
Print "Max_schritte_k3: " ; Max_schritte_k3
Print "Max_schritte_k4: " ; Max_schritte_k4
Print "Synchron: " ; Synchron
Print "Invertiert: " ; Invertiert
Print "Timer0: " ;
If Vorteiler = 4 Then Print "256" Else Print "1024"
'Print "Schritte:254"
Print "Ende"

Select Case Vorteiler
   Case 5
      Tccr0 = 5                                             'Vorteiler = 1024
   Case 4
      Tccr0 = 4                                             'Vorteiler = 256
   Case Else
      Vorteiler_eeprom = 5
      Tccr0 = 5
End Select

If Modus_k3 = 0 Then
   'Leuchtstoffrhren an K3, dann Redefinition PORTA.7
   Config Porta.7 = Input : Porta.7 = 1
   'Print "Leuchtstoffroehren"
Else
   Config K3_8 = Output
End If

If Modus_k2 = 0 Then
   'Blinklichter an K2, dann PWM einrichten
   Config Timer1 = Pwm , Pwm = 8 , Compare_a_pwm = Clear_up , Compare_b_pwm = Clear_up , Prescale = 1
   Compare1a = 0
   'print "Compare1A: " ; Compare1a
   Compare1b = 0
   'print "Compare1B: " ; Compare1b
   K2_3 = 1
   K2_4 = 0
End If


'nun beginnt die endlose Schleife des normalen Betriebs
Do
   If Befehlkomplett = 1 Then
      Befehlkomplett = 0
      'Print Befehl ; "!"
      If Modus = 0 Then
         If Befehl = "Modus:2       " Then
            Modus_eeprom = 2
            Waitms 10
            Hilf = Modus_eeprom
            Print "Modus: " ; Hilf
            Neustart = 1
         End If
         If Befehl = "Ausgabe       " Then
               For Schleife = 1 To 128
                  K2_wert = K2_eeprom(schleife)
                  Print "K:2:" ; Schleife ; ":" ; K2_wert
               Next
               For Schleife = 1 To 128
                  K3_wert = K3_eeprom(schleife)
                  Print "K:3:" ; Schleife ; ":" ; K3_wert
               Next
               For Schleife = 1 To 128
                  K4_wert = K4_eeprom(schleife)
                  Print "K:4:" ; Schleife ; ":" ; K4_wert
               Next
               Print "Fertig"
         End If
      Else
         'nicht Modus = 0
         If Modus = 1 Then
            'Test-Modus per PC aktiv, geht nur aus Modus 2 heraus!
            If Befehl = "Modus:2       " Then
               'wieder zurck in Modus 2
               Modus = 2
               Print "Text-Modus inaktiv"
               Neustart = 1
            End If
            Befehl6 = Left(befehl , 6)
            Param1 = Val(wert1)
            Select Case Befehl6
               Case "K2test"
                  K2_wert = Param1
                  Gosub K2_schreiben
               Case "K3test"
                  K3_wert = Param1
                  Gosub K3_schreiben
               Case "K4test"
                  K4_wert = Param1
                  Gosub K4_schreiben
            End Select
         Else
            Select Case Befehl
               Case "Ausgabe       "
                  For Schleife = 1 To 128
                     K2_wert = K2_eeprom(schleife)
                     Print "K:2:" ; Schleife ; ":" ; K2_wert
                  Next
                  For Schleife = 1 To 128
                     K3_wert = K3_eeprom(schleife)
                     Print "K:3:" ; Schleife ; ":" ; K3_wert
                  Next
                  For Schleife = 1 To 128
                     K4_wert = K4_eeprom(schleife)
                     Print "K:4:" ; Schleife ; ":" ; K4_wert
                  Next
                  Print "Fertig"
               Case "Modus:0       "
                  Modus_eeprom = 0
                  Waitms 10
                  Hilf = Modus_eeprom
                  Print "Modus: " ; Hilf
                  Neustart = 1
               Case "Modus_k2:0    "
                  Modus_k2_eeprom = 0
                  Waitms 10
                  Hilf = Modus_k2_eeprom
                  Print "Modus_k2: " ; Hilf
                  Neustart = 1
               Case "Modus_k2:1    "
                  Modus_k2_eeprom = 1
                  Waitms 10
                  Hilf = Modus_k2_eeprom
                  Print "Modus_k2: " ; Hilf
                  Neustart = 1
               Case "Modus_k3:0    "
                  Modus_k3_eeprom = 0
                  Waitms 10
                  Hilf = Modus_k3_eeprom
                  Print "Modus_k3: " ; Hilf
                  Neustart = 1
               Case "Modus_k3:1    "
                  Modus_k3_eeprom = 1
                  Waitms 10
                  Hilf = Modus_k3_eeprom
                  Print "Modus_k3: " ; Hilf
                  Neustart = 1
               Case "Modus_k4:0    "
                  Modus_k4_eeprom = 0
                  Waitms 10
                  Hilf = Modus_k4_eeprom
                  Print "Modus_k4: " ; Hilf
                  Neustart = 1
               Case "Modus_k4:1    "
                  Modus_k4_eeprom = 1
                  Waitms 10
                  Hilf = Modus_k4_eeprom
                  Print "Modus_k4: " ; Hilf
                  Neustart = 1
               Case "Modus_k4:2    "
                  Modus_k4_eeprom = 2
                  Waitms 10
                  Hilf = Modus_k4_eeprom
                  Print "Modus_k4: " ; Hilf
                  Neustart = 1
               Case "Modus_k4:3    "
                  Modus_k4_eeprom = 3
                  Waitms 10
                  Hilf = Modus_k4_eeprom
                  Print "Modus_k4: " ; Hilf
                  Neustart = 1
               Case "Modus:1       "
                  'Test-Modus per PC aktivieren
                  Modus = 1
                  Print "Test-Modus aktiv"
                  K2_wert = 0
                  Gosub K2_schreiben
                  K3_wert = 0
                  Gosub K3_schreiben
                  K4_wert = 0
                  Gosub K4_schreiben
' ******Experiment 6.4.2017
               Case "Timer0  :1024 "
                  Tccr0 = 5
                  Vorteiler_eeprom = 5
                  Print "Timer0: 1024"
                  Waitms 10
                  Neustart = 1
               Case "Timer0  :256  "
                  Tccr0 = 4
                  Vorteiler_eeprom = 4
                  Print "Timer0: 256"
                  Waitms 10
                  Neustart = 1
               Case Else
                  Befehl6 = Left(befehl , 6)
                  Param1 = Val(wert1)
                  Param2 = Val(wert2)
                  Select Case Befehl6
                     Case "K2_max"
                        Zaehlerk2_max_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K3_max"
                        Zaehlerk3_max_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K4_max"
                        Zaehlerk4_max_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K2_sch"
                        Max_schritte_k2_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K3_sch"
                        Max_schritte_k3_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K4_sch"
                        Max_schritte_k4_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "K2wert"
                        K2_eeprom(param1) = Param2
                        Waitms 10
                     Case "K3wert"
                        K3_eeprom(param1) = Param2
                        Waitms 10
                     Case "K4wert"
                        K4_eeprom(param1) = Param2
                        Waitms 10
                     Case "Synchr"
                        Synchron_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case "Invert"
                        Invertiert_eeprom = Param1
                        Waitms 10
                        Neustart = 1
                     Case Else
                        Print "was war das?" ; Befehl
                  End Select
            End Select
         End If
      End If
      Befehl = ""
   End If

   If Modus <> 1 Then                                       'im testbetrieb per PC lassen wir das
      If K2_verarbeiten = 1 Then
         'es gibt was an K2 zu tun, der Timer0 hat's gesagt
         K2_verarbeiten = 0                                 'gleich wieder zurcksetzen
         '************************************************************
         '* Wohnhaus an K2
         '************************************************************
         If Modus_k2 = 1 Then
            Incr K2_schritt                                 'wird von 1 bis 128 hochgezhlt
            If K2_schritt = Max_schritte_k2 Then
               K2_schritt = 1
            End If
            K2_wert = K2_eeprom(k2_schritt)
            Gosub K2_schreiben
         End If
      End If
      If K3_verarbeiten = 1 Then
         'nun ist K3 an der Reihe
         K3_verarbeiten = 0
         '************************************************************
         '* Wohnhaus an K3
         '************************************************************
         If Modus_k3 = 1 Then
            Incr K3_schritt
            If K3_schritt = Max_schritte_k3 Then
               K3_schritt = 1
            End If
            K3_wert = K3_eeprom(k3_schritt)
            Gosub K3_schreiben
         End If
      End If
      If K4_verarbeiten = 1 Then
         'und jetzt noch K4
         K4_verarbeiten = 0
         '************************************************************
         '* Wohnhaus an K4
         '************************************************************
         If Modus_k4 = 3 Then                               'der hat 4 Modi!
            Incr K4_schritt
            If K4_schritt = Max_schritte_k4 Then
               K4_schritt = 1
            End If
            K4_wert = K4_eeprom(k4_schritt)
            Gosub K4_schreiben
         End If
      End If
      '************************************************************
      '* Lauflicht, aufwrts wandernder Lichtpunkt
      '************************************************************
      If Modus_k4 = 1 Then
         If Zaehlerk4_alt <> Zaehlerk4 Then
            'es sind 0,131072 Sekunden vergangen
            Zaehlerk4_alt = Zaehlerk4
            Incr Lauflicht
            If Lauflicht = 8 Then
               Lauflicht = 0
            End If
            K4_wert = 2 ^ Lauflicht
            Gosub K4_schreiben
         End If
      End If
      '************************************************************
      '* Lauflicht, hin- und her wandernder Lichtpunkt
      '************************************************************
      If Modus_k4 = 0 Then
         If Zaehlerk4_alt <> Zaehlerk4 Then
            'es sind 0,131072 Sekunden vergangen
            Zaehlerk4_alt = Zaehlerk4
            Incr Lauflicht
            If Lauflicht = 14 Then
               Lauflicht = 0
            End If
            If Lauflicht < 8 Then
               K4_wert = 2 ^ Lauflicht
            Else
               Hilf = 14 - Lauflicht
               K4_wert = 2 ^ Hilf
            End If
            Gosub K4_schreiben
         End If
      End If
      '************************************************************
      '* Lauflicht, wachsender Balken
      '************************************************************
      If Modus_k4 = 2 Then
         If Zaehlerk4_alt <> Zaehlerk4 Then
            'es sind 0,131072 Sekunden vergangen
            Zaehlerk4_alt = Zaehlerk4
            Incr Lauflicht
            If Lauflicht = 10 Then
               Lauflicht = 0
            End If
            Select Case Lauflicht
               Case 9
                  K4_wert = 0
               Case 0 To 7
                  K4_wert.lauflicht = 1
            End Select
            Gosub K4_schreiben
         End If
      End If
      '************************************************************
      '* diverse Blinklichter an K2
      '************************************************************
      If Modus_k2 = 0 Then
         'der "weiche" Wechselblinker
         If Zaehler5 <> Zaehler5_alt Then
            Zaehler5_alt = Zaehler5
            Incr Wechselblinker
            If Wechselblinker = 71 Then
               Wechselblinker = 1
            End If
            Select Case Wechselblinker
               Case 0 To 17
                  Hilf = Compare1a + 15
                  Compare1a = Hilf
                  Compare1b = 255 - Hilf
               Case 36 To 52
                  Hilf = Compare1a - 15
                  Compare1a = Hilf
                  Compare1b = 255 - Hilf
            End Select
            'der Rettungswagen
            Incr Rettungsfahrzeug
            If Rettungsfahrzeug = 36 Then
               Rettungsfahrzeug = 0
            End If
            Hilf = Lookup(rettungsfahrzeug , Rettungsfahrzeug_muster)
            K2_5 = Hilf.3
            K2_6 = Hilf.2
            K2_7 = Hilf.1
            K2_8 = Hilf.0
            'der "harte" Wechselblinker
            Incr Blinker
            'print "Blinker: " ; Blinker
            Hilf = Blinker Mod 16
            If Hilf = 0 Then
               Toggle K2_3
               Toggle K2_4
            End If
         End If
      End If
      '************************************************************
      '* Leuchtstoffrhren an K3
      '************************************************************
      If Modus_k3 = 0 Then
         Leuchtstoff = Pina.7                               'Alias geht nicht
         If Leuchtstoff = 1 Then
            'Leuchtstoffrhren aus
            Leuchtstoffzaehler = 0
            K3_wert = 0
            Gosub K3_schreiben
         Else
            If Zaehler4_alt <> Zaehler4 Then
               Zaehler4_alt = Zaehler4
               If Leuchtstoffzaehler < 112 Then
                  Incr Leuchtstoffzaehler
                  'Print "Leuchtstoffzaehler:" ; Leuchtstoffzaehler ; " K3_wert: " ; K3_wert
                  If Leuchtstoffzaehler > 1 Then
                     K3_wert = Flackern(leuchtstoffzaehler)
                  End If
                  Gosub K3_schreiben
                  'Print "K3_wert: " ; K3_wert
               Else
                  K3_wert = 255
                  Gosub K3_schreiben
                  'Print "Leuchtstoffzaehler:" ; Leuchtstoffzaehler ; " K3_wert: " ; K3_wert
               End If
            End If
         End If
      End If
   End If
Loop Until Neustart = 1
Neustart = 0
Goto Programmbeginn
'hier endet die "endlose" Schleife

end

'Subs fr Schreiben der Werte auf die Ausgnge
'hier werden die Bits wieder richtig den Anschlssen zugeordnet
'ausserdem werden die Bits invertiert, d. h. Bit=0 => LED aus, Bit=1 => LED ein
K2_schreiben:
   If Invertiert = 1 Then
      K2_1 = K2_wert.0
      K2_2 = K2_wert.1
      K2_3 = K2_wert.2
      K2_4 = K2_wert.3
      K2_5 = K2_wert.4
      K2_6 = K2_wert.5
      K2_7 = K2_wert.6
      K2_8 = K2_wert.7
   Else
      K2_1 = Not K2_wert.0
      K2_2 = Not K2_wert.1
      K2_3 = Not K2_wert.2
      K2_4 = Not K2_wert.3
      K2_5 = Not K2_wert.4
      K2_6 = Not K2_wert.5
      K2_7 = Not K2_wert.6
      K2_8 = Not K2_wert.7
   End If
Return

K3_schreiben:
   If Invertiert = 1 Then
      K3_1 = K3_wert.0
      K3_2 = K3_wert.1
      K3_3 = K3_wert.2
      K3_4 = K3_wert.3
      K3_5 = K3_wert.4
      K3_6 = K3_wert.5
      K3_7 = K3_wert.6
   Else
      K3_1 = Not K3_wert.0
      K3_2 = Not K3_wert.1
      K3_3 = Not K3_wert.2
      K3_4 = Not K3_wert.3
      K3_5 = Not K3_wert.4
      K3_6 = Not K3_wert.5
      K3_7 = Not K3_wert.6
   End If
   If Modus_k3 = 1 Then
      'nur wenn nicht als Leuchtstoffrhren benutzt!
      If Invertiert = 1 Then
         K3_8 = K3_wert.7
      Else
         K3_8 = Not K3_wert.7
      End If
      'Print "!" ; K3_wert.7 ; " ";
   End If
Return

K4_schreiben:
   If Invertiert = 1 Then
      K4_1 = K4_wert.0
      K4_2 = K4_wert.1
      K4_3 = K4_wert.2
      K4_4 = K4_wert.3
      K4_5 = K4_wert.4
      K4_6 = K4_wert.5
      K4_7 = K4_wert.6
      K4_8 = K4_wert.7
   Else
      K4_1 = Not K4_wert.0
      K4_2 = Not K4_wert.1
      K4_3 = Not K4_wert.2
      K4_4 = Not K4_wert.3
      K4_5 = Not K4_wert.4
      K4_6 = Not K4_wert.5
      K4_7 = Not K4_wert.6
      K4_8 = Not K4_wert.7
   End If
Return
'***********************************************************************************
'Interrupt-Routinen
Irqtimer0:
'bei Aufruf alle 0,131072 Sekunden erreicht die Byte-Variable ZaehlerK2
'bei Zaehlerk2_max = 255 nach 33,42336 Sekunden den Nullpunkt
'bei kleinerem Zaehlerx_max entsprechend frher

   Incr Zaehlerk2
   Incr Zaehlerk3
   Incr Zaehlerk4
   If Zaehlerk2 >= Zaehlerk2_max Then
      Zaehlerk2 = 0
   End If
   If Zaehlerk3 >= Zaehlerk3_max Then
      Zaehlerk3 = 0
   End If
   If Zaehlerk4 >= Zaehlerk4_max Then
      Zaehlerk4 = 0
   End If
   If Zaehlerk2 = 0 Then
      K2_verarbeiten = 1
   End If
   If Zaehlerk3 = 0 Then
      K3_verarbeiten = 1
   End If
   If Zaehlerk4 = 0 Then
      K4_verarbeiten = 1
   End If
Return

Irqtimer2:
   'fr Flackern der Leuchtstoffrhren und Blinklichter
   Incr Zaehler4
   Incr Zaehler5
Return

Onrxd:
   '***************************************************************
   '** ISR fr Empfang eines Zeichens via serielle Schnittstelle **
   '***************************************************************
   'bei Empfang eines Zeichens Zhler um 1 erhhen
   Zeichen = Udr
   Incr Stringzaehler
   'Print Zeichen;

   If Zeichen = 13 Then
      'Zeilenende gesendet, Befehl komplett?
      If Stringzaehler = 15 Then
        'jetzt haben wir einen kompletten Befehl
        Befehl = Befehlsammeln                              'das was wir empfangen haben umkopieren
        Befehlkomplett = 1                                  'jetzt kann der Befehl verarbeitet werden
        'Print Befehl
      Else
        'das war Mll!
        Print "Muell"
      End If
      'egal wie, stringzaehler auf 0
      Stringzaehler = 0
   Else
     'ein weiteres Zeichen sammeln
     Befehlsamm(stringzaehler) = Zeichen                    'empfangenes Zeichen anhngen
   End If
Return


'damit weisen wir den Compiler an, diese Werte im EEPROM abzulegen. Es wird zunchste eine
'Datei "xyz.EEP" erzeugt, diese wird beim Brennen im EEPROM abgelegt
'das funktioniert aber nur wenn die Kommentarzeichen entfernt werden!
'Das EEPROM-Schreiben kann man in den Programmer-Optionen verhindern: Upload Code an Data ausschalten

$eeprom
'K2_eeprom - das ist wirklich ein Kommentar!
Data 129 , 129 , 129 , 129 , 193 , 193 , 65 , 65 , 67 , 67 , 67 , 71 , 7 , 7 , 15 , 15,
Data 14 , 14 , 14 , 14 , 30 , 30 , 62 , 62 , 62 , 62 , 190 , 190 , 158 , 158 , 156 , 156,
Data 156 , 156 , 28 , 28 , 28 , 28 , 28 , 92 , 92 , 93 , 95 , 95 , 31 , 27 , 27 , 27,
Data 59 , 59 , 43 , 11 , 11 , 139 , 137 , 137 , 137 , 137 , 137 , 137 , 141 , 13 , 13 , 13,
Data 13 , 13 , 77 , 77 , 92 , 92 , 88 , 88 , 88 , 88 , 120 , 248 , 248 , 104 , 104 , 104,
Data 104 , 104 , 96 , 224 , 160 , 160 , 160 , 160 , 160 , 162 , 162 , 162 , 162 , 178 , 176 , 48,
Data 48 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 36 , 36 , 36 , 52 , 112,
Data 80 , 80 , 80 , 84 , 84 , 84 , 84 , 86 , 86 , 86 , 87 , 119 , 117 , 101 , 37 , 37,
'K3_eeprom - das ist wirklich ein Kommentar!
Data 8 , 24 , 26 , 10 , 10 , 138 , 138 , 131 , 195 , 87 , 87 , 87 , 117 , 52 , 52 , 52,
Data 60 , 44 , 44 , 72 , 8 , 8 , 8 , 8 , 8 , 8 , 8 , 8 , 24 , 24 , 154 , 219,
Data 155 , 25 , 25 , 28 , 28 , 92 , 92 , 92 , 84 , 20 , 20 , 20 , 20 , 20 , 20 , 52,
Data 52 , 52 , 116 , 244 , 180 , 180 , 180 , 165 , 165 , 133 , 133 , 133 , 133 , 13 , 12 , 12,
Data 12 , 12 , 12 , 12 , 12 , 12 , 12 , 142 , 142 , 142 , 142 , 158 , 30 , 30 , 92 , 84,
Data 20 , 20 , 20 , 4 , 4 , 4 , 4 , 4 , 36 , 36 , 36 , 52 , 48 , 178 , 178 , 210,
Data 146 , 18 , 18 , 18 , 18 , 18 , 82 , 18 , 178 , 34 , 32 , 40 , 40 , 40 , 168 , 168,
Data 169 , 169 , 129 , 197 , 197 , 197 , 197 , 197 , 193 , 65 , 65 , 17 , 17 , 17 , 17 , 17,
'K4_eeprom - das ist wirklich ein Kommentar!
Data 32 , 48 , 48 , 48 , 48 , 48 , 48 , 48 , 176 , 176 , 176 , 176 , 240 , 112 , 112 , 112,
Data 52 , 52 , 37 , 37 , 37 , 37 , 165 , 132 , 132 , 132 , 132 , 128 , 144 , 146 , 18 , 18,
Data 18 , 2 , 2 , 130 , 130 , 2 , 64 , 64 , 72 , 73 , 73 , 9 , 9 , 153 , 81 , 16,
Data 16 , 16 , 20 , 20 , 69 , 69 , 69 , 69 , 69 , 69 , 69 , 67 , 3 , 3 , 19 , 19,
Data 147 , 211 , 67 , 1 , 1 , 1 , 9 , 9 , 9 , 137 , 137 , 153 , 153 , 217 , 209 , 213,
Data 213 , 148 , 132 , 132 , 36 , 36 , 36 , 164 , 37 , 5 , 21 , 17 , 17 , 16 , 16 , 16,
Data 16 , 16 , 16 , 0 , 0 , 2 , 2 , 34 , 34 , 34 , 162 , 162 , 38 , 38 , 36 , 36,
Data 36 , 109 , 77 , 5 , 1 , 1 , 33 , 33 , 41 , 41 , 41 , 141 , 141 , 133 , 133 , 69,
'Flacker-Muster Leuchtstoffrhren - das ist wirklich ein Kommentar!
Data 5 , 4 , 41 , 40 , 84 , 1 , 19 , 39 , 76 , 44 , 24 , 97 , 68 , 18 , 49 , 34,
Data 85 , 77 , 69 , 81 , 19 , 55 , 54 , 50 , 42 , 104 , 97 , 35 , 36 , 84 , 81 , 19,
Data 87 , 114 , 42 , 120 , 88 , 16 , 18 , 50 , 98 , 105 , 105 , 125 , 92 , 92 , 20 , 22,
Data 2 , 67 , 67 , 67 , 81 , 85 , 21 , 21 , 21 , 77 , 77 , 77 , 109 , 103 , 39 , 43,
Data 43 , 11 , 9 , 17 , 17 , 17 , 20 , 84 , 68 , 102 , 102 , 98 , 51 , 59 , 121 , 125,
Data 125 , 108 , 108 , 10 , 26 , 27 , 89 , 93 , 77 , 77 , 78 , 30 , 23 , 19 , 51 , 59,
Data 123 , 127 , 125 , 109 , 109 , 77 , 95 , 95 , 23 , 19 , 83 , 75 , 75 , 75 , 43 , 43,

Data 0                                                      'das ist der Standardwert fr Modus
Data 1                                                      'das ist der Standardwert fr Modus_k2
Data 1                                                      'das ist der Standardwert fr Modus_k3
Data 3                                                      'das ist der Standardwert fr Modus_k4 (4 Werte!)
Data 38                                                     'das ist der Standardwert fr Zaehlerk2_max
Data 38                                                     'das ist der Standardwert fr Zaehlerk3_max
Data 38                                                     'das ist der Standardwert fr Zaehlerk4_max
Data 129                                                    'das ist der Standardwert fr Max_schritte_k2 (minus 1!)
Data 129                                                    'das ist der Standardwert fr Max_schritte_k3
Data 129                                                    'das ist der Standardwert fr Max_schritte_k4

'Wert fr synchron_eeprom
Data 0
'Wert fr Invertiert
Data 0
'Wert fr Vorteiler
Data 5

$data
Rettungsfahrzeug_muster:
Data 9
Data 9
Data 9
Data 9
Data 9
Data 9
Data 10
Data 10
Data 10
Data 10
Data 10
Data 10
Data 1
Data 9
Data 1
Data 9
Data 1
Data 9
Data 6
Data 6
Data 6
Data 6
Data 6
Data 6
Data 5
Data 5
Data 5
Data 5
Data 5
Data 5
Data 2
Data 6
Data 2
Data 6
Data 2
Data 6